; this will be loaded just after registering console commands
; but before execing dsp.script
; ALISP3 system switchers
(sys-lisp-optimization *t*)
(sys-throw-errors *f*)

(setq dsp *t*)
(setq dsp-version '(0 2 0 1))
(setq dsp-version-str "0.2.0 RC1")

(setq prev-snap-file *nil*)
(setq latest-snap-file *nil*)

; dummy definition
; this is hardcoded into the DSP
;(defun ed06-trap (addr) (begin (println "#ED/#06 trap at " addr) (con-execute "activate_debugger")))

; dummy definition
; this is hardcoded into the DSP
;(defun slt-trap (addr level) (begin (println "SLT trap at " addr) (con-execute "activate_debugger") *f*))

(defun on-loaded () *nil*)

;(verbose-load init-temp-vl)
;(undefine init-temp-vl)
(load "stdlib/listtoolz")
(load "stdlib/miscutilz")
(load "stdlib/fileutilz")

;(load "asm/lasm")
(load "baslist")
(load "zxprint")
(load "inf_eng")
(load "rpok")
(load "savemem")


(defun post-qsave (qname | fh)
  (setq fh (fopen (change-ext qname ".l") "c"))

  (fwrite-byte fh 40)
  (fwrite-str fh "setq prev-snap-file ")
  (if prev-snap-file
    (begin (fwrite-byte fh 34) (fwrite-str fh (escape-str prev-snap-file)) (fwrite-byte fh 34))
   (fwrite-str fh "*nil*")
  )
  (fwrite-byte fh 41)
  (fwrite-byte fh 10)

  (fwrite-byte fh 40)
  (fwrite-str fh "setq latest-snap-file ")
  (if latest-snap-file
    (begin (fwrite-byte fh 34) (fwrite-str fh (escape-str latest-snap-file)) (fwrite-byte fh 34))
   (fwrite-str fh "*nil*")
  )
  (fwrite-byte fh 41)
  (fwrite-byte fh 10)

  (fwrite-str fh "(load (change-ext latest-snap-file \".l\"))")

  (fclose fh)
)

(load "console/cmdz")
