// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
unit dspMachConstU;

interface


type
  TZXModel = (zxm48k, zxm128kReal, zxm128k, zxmPentagon128k);

  TVSPosInfo = record
    border: Boolean;
    zxscr: Word;    // Speccy screen pos ($FFFF - border or offscreen)
    zxattr: Word;   // Speccy screen attr pos ($FFFF - border or offscreen)
    vscrA: Integer; // -1: draw nothing
    bshift: Byte;   // shr count to get the corresponding 2 pixels from byte
  end;


const
  emuModelNames: array [TZXModel] of string = (
    'ZX Spectrum 48K',
    'ZX Spectrum 128K',
    'ZX Spectrum 128K',
    'Pentagon 128K');


var
  emuLineTStates: array [0..240] of Integer;
  emuXULAContention: array [0..79999] of Integer;
  emuModel: TZXModel;
  emuTicksIntr: Integer;
    // t-states in one intr
  emuTicksLine: Integer;
    // t-states in one screen line
  emuTicksLBord: Integer;
  emuTicksRBord: Integer;
  emuTicksRetrace: Integer;
  emuScrFirst: Boolean;


implementation


end.
